/*
** System Call Modules Header File
*/


/***********************************************************************
** Standard header preamble.  Ensure singular inclusion, setup for
** function prototypes and c++ inclusion
*/

#ifndef MOD_SYSCALL_H

#define MOD_SYSCALL_H 1

#if defined(__STDC__) || defined(__cplusplus)
#  define __ANSI_PROTO(x)       x
#else
#  define __ANSI_PROTO(x)       ()
#endif

#ifdef __cplusplus
extern "C" {
#endif



/***********************************************************************
** Macro Definitions
*/


/***********************************************************************
** Type Definitions
*/


/***********************************************************************
** Function Prototypes
*/


/***********************************************************************
** Standard header file footer.  
*/

#ifdef __cplusplus
	}
#endif /* __cplusplus */
#endif /* file inclusion */


int	doExit();
int	doUnlink();
int	doChmod();
int	doChown();
int	doSystem();
int	doSleep();
int	doUmask();
int	doGetpid();
int	doGetppid();

int	doGetCwd();
int	doChdir();
int	doMkdir();
int	doRmdir();
int	doRename();
int	doTruncate();
int	doLink();
int	doSymlink();
int	doTest();
int	doKill();
int	doStat();
int	doTime();
int	doGetTzOffset();
int	doSrandom();
int	doRandom();
int	doCTime();
int	doGetUid();
int	doGetGid();
int	doGetEuid();
int	doGetEnv();
int	doGetPwNam();
int	doGetPwUid();

e_extern syscall_externs [] = {
        { "unlink", doUnlink, "", 1, { EMBER_TYPE_TEXT, 0} },
        { "chmod", doChmod, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_INT, 0} },
        { "chown", doChown, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "umask", doUmask, "", 1, { EMBER_TYPE_INT, 0} },
        { "getcwd", doGetCwd, "", 0, { 0} },
        { "chdir", doChdir, "", 1, { EMBER_TYPE_TEXT, 0} },
        { "mkdir", doMkdir, "", 1, { EMBER_TYPE_TEXT, 0} },
        { "rmdir", doRmdir, "", 1, { EMBER_TYPE_TEXT, 0} },
        { "rename", doRename, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "truncate", doTruncate, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_INT, 0}},
        { "link", doLink, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "symlink", doSymlink, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },

        { "system", doSystem, "", 1, { EMBER_TYPE_TEXT, 0} },
        { "sleep", doSleep, "", 1, { EMBER_TYPE_INT, 0} },
        { "getpid", doGetpid, "", 0, { 0} },
        { "getppid", doGetppid, "", 0, { 0} },
        { "exit", doExit, "", 1, { EMBER_TYPE_INT, 0} },
        { "test", doTest, "", 2, { EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "kill", doKill, "", 2, { EMBER_TYPE_INT, EMBER_TYPE_INT, 0} },
        { "stat", doStat, "", 1, { EMBER_TYPE_TEXT, 0} },
        { "time", doTime, "", 0, { 0} },
        { "getTzOffset", doGetTzOffset, "", 0, { 0} },
        { "srandom", doSrandom, "", 1, { EMBER_TYPE_INT, 0} },
        { "random", doRandom, "", 0, { 0} },
        { "ctime", doCTime, "", 1, { EMBER_TYPE_INT, 0} },
        { "getuid", doGetUid, "", 0, { 0} },
        { "geteuid", doGetEuid, "", 0, { 0} },
        { "getgid", doGetGid, "", 0, { 0} },
	{ "getenv", doGetEnv, "", 1, { EMBER_TYPE_TEXT, 0} },
	{ "getpwnam", doGetPwNam, "", 1, { EMBER_TYPE_TEXT, 0} },
	{ "getpwuid", doGetPwUid, "", 1, { EMBER_TYPE_INT, 0} },

	{ NULL }
};

void (*syscall_init_function)() = NULL;
